% Example_9_1
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Halfband FIR filters in multistage multirate filter
close all, clear all
F0 = 2000;                                                                                   % Sampling frequency [Hz]
Fp = 230;                                                                                     %  Passband edge frequency [Hz]
Fs = 300;                                                                                      % Stopband edge frequency [Hz]
delta = 0.001;                                                                               % Peak stopband ripple
Nord_k = 50;                                                                                 % Setting the kernel filter order
hk = firgr(50,[0,2*Fp/(F0/2),2*Fs/(F0/2),1],[1,1,0,0]);                    % Designing the kernel filter
hd = firhalfband('minorder',(2*Fs + Fp)/(3*F0/2),delta);                % Designing the decimation filter
hi = hd;                                                                                          % Interpolation filter

[Hk,F] = freqz(upsample(hk,2),1,1024,F0);
[Hd,F] = freqz(hd,1,1024,F0);
figure (1)
subplot(2,1,1)
plot(F,20*log10(abs(Hk)),F,20*log10(abs(Hd)),'b')
ylabel('Gain [dB]')
axis([0,1000,-80,5])
hold on
%hi = hd;
Hi = Hd;
H = (Hd.*Hk).*Hi;
figure (1)
subplot(2,1,2)
plot(F,20*log10(abs(H))),ylabel('Gain [dB]')
axis([0,1000,-80,5])
hold on
n=1:length(hd);
%hd_al=hd.*(-1.^n)
%[Hd_al,F] = freqz(hd_al,1,1024,F0);
[Hd_al,F]=freqz(hd,1,2048,F0,'whole');
figure (1)
subplot(2,1,1)
plot(F(1:1024),20*log10(abs(Hd_al(1025:2048))),'--')
Hd_a=Hd_al(1025:2048);
Alias=(Hd_a.*Hk).*Hi;
figure (1)
subplot(2,1,2)
plot(F(1:1024),20*log10(abs(Alias)),'--')
xlabel('Frequency [Hz]')
