% Example_9_2
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Halfband IIR filters in multistage multirate filter
close all, clear all
F0 = 2000;
Fp = 250;
Fs = 300;
delta = 0.001;
[B,A,beta,Ap,As,Fp,F3db]=emqf_igi(9,1/16+1/32+1/256,0.3);
[bd,ad,z,p,k] = halfbandiir(5,2*F3db*1000/F0);
%hd = firhalfband('minorder',(Fs)/(F0/2),delta)
[Hk,F] = freqz(upsample(B,2)/2,upsample(A,2),1024,F0);
[Hd,F] = freqz(bd,ad,1024,F0);
figure (1)
subplot(2,1,1)
plot(F,20*log10(abs(Hk)),F,20*log10(abs(Hd)),'b')
ylabel('Gain [dB]')
axis([0,1000,-80,5])
hold on
%hi = hd;
Hi = Hd;
H = (Hd.*Hk).*Hi;
figure (1)
subplot(2,1,2)
plot(F,20*log10(abs(H))),ylabel('Gain [dB]')
axis([0,1000,-80,5])
hold on
%n=1:length(hd);
%hd_al=hd.*(-1.^n)
%[Hd_al,F] = freqz(hd_al,1,1024,F0);
[Hd_al,F]=freqz(bd,ad,2048,F0,'whole');
figure (1)
subplot(2,1,1)
plot(F(1:1024),20*log10(abs(Hd_al(1025:2048))),'--')
Hd_a=Hd_al(1025:2048);
Alias=(Hd_a.*Hk).*Hi;
figure (1)
subplot(2,1,2)
plot(F(1:1024),20*log10(abs(Alias)),'--')
xlabel('Frequency [Hz]')
