% Examples_9_5_6
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Halfband FIR filters in multistage multirate filter, highpass filter case
close all, clear all
F0 = 2000;
Fp = 230;
Fs = 300;
delta = 0.0003;
hk = firgr(62,[0,2*Fp/(F0/2),2*Fs/(F0/2),1],[1,1,0,0]);
hd = firhalfband('minorder',(2*Fs+Fp)/(3*F0/2),delta);
n=0:length(hd)-1;
hd=hd.*(-1).^n;
%hd = firlp2hp(hd,'wide');
[Hk,F] = freqz(upsample(hk,2),1,1024,F0);
[Hd,F] = freqz(hd,1,1024,F0);
figure (1)
subplot(2,1,1)
plot(F,20*log10(abs(Hk)),F,20*log10(abs(Hd)),'b')
ylabel('Gain [dB]')
axis([0,1000,-100,5])
hold on
hi = hd;
Hi = Hd;
H = (Hd.*Hk).*Hi;
figure (1)
subplot(2,1,2)
plot(F,20*log10(abs(H))),ylabel('Gain [dB]')
axis([0,1000,-100,5])
hold on
n=1:length(hd);

[Hd_al,F1]=freqz(hd,1,2048,F0,'whole');
figure (1)
subplot(2,1,1)
plot(F1(1:1024),20*log10(abs(Hd_al(1025:2048))),'--')
Hd_a=Hd_al(1025:2048);
Alias=(Hd_a.*Hk).*Hi;
figure (1)
subplot(2,1,2)
plot(F1(1:1024),20*log10(abs(Alias)),'--')
xlabel('Frequency [Hz]')
D=length(hk)+length(hd)

HH=ones(size(1:length(H)));
D=length(hk)+length(hd)-2

HH=ones(size(1:length(H))).*exp(-i*2*pi*F*D/F0)'-H';
figure (2)
plot(F,20*log10(abs(HH)),F1(1:1024),20*log10(abs(Alias)),'--'),ylabel('Gain [dB]'),xlabel('Frequency [Hz]')
axis([0,1000,-120,5]),grid
g(1)=axes('Position',[0.25 0.70 0.45 0.1]);
plot(F(1:750),(abs(HH(1:750)))), axis([0,730,0.9998,1.0002]),grid
hy=conv(downsample(hd,2),hk);
hy=conv(upsample(hy,2),2*hi);
hdel=zeros(size(1:length(hy)));
D=(length(hdel))/2
hdel(D)=1;
hh=hdel-hy;
figure (3)
[HH,F]=freqz(hh,1,1024,F0);
plot(F,20*log10(abs(HH)),F1(1:1024),20*log10(abs(Alias)),'--b'), ylabel('Gain [dB]'),xlabel('Frequency [Hz]')
grid
axis([0,1000,-120,5])
g(2)=axes('Position',[0.25 0.70 0.45 0.1]);
plot(F(1:750),(abs(HH(1:750)))), axis([0,730,0.9998,1.0002]),grid


hd1 = firhalfband('minorder',(2*Fs+2.2*Fp)/(3*F0/2),delta);
n=0:length(hd1)-1;
hd1_a=hd1.*(-1).^n;
F0=4000;
%n=0:length(hd1)-1;
%hd1=hd1.*(-1).^n;
hi1 = hd1;
hy1=conv(downsample(hd1,2),hh);
hy1=conv(upsample(hy1,2),2*hi1);
[Hd1,F1]=freqz(hd1,1,1024,4000);
[Hd1_a,F1]=freqz(hd1_a,1,1024,4000);
figure (4)
plot(F1,20*log10(abs(Hd1)))
hold on
plot(F1,20*log10(abs(Hd1_a)),'--')
[HHu,F]=freqz(upsample(hh,2),1,1024,4000);
plot(F1,20*log10(abs(HHu)),'r'),ylabel('Gain [dB]'),xlabel('Frequency [Hz]'),grid
axis([0,2000,-120,5])
hdel1=zeros(size(1:length(hy1)));
D1=(length(hdel1))/2
hdel(D1)=1;
hh1=hdel1+hy1;
figure (5)
[HH1,F]=freqz(hh1,1,1024,F0);
plot(F,20*log10(abs(HH1)));
hold on
Alias_1=(Hd1_a.*HHu).*Hd1;
plot(F,20*log10(abs(Alias_1)),'--b');
Alias_1a=Alias.*Hd1;
plot(F,20*log10(Alias_1a),'-.b'),ylabel('Gain [dB]'),xlabel('Frequency [Hz]')
grid
axis([0,2000,-120,5])
g(3)=axes('Position',[0.5 0.70 0.40 0.1]);
plot(F(1:450),(abs(HH1(1:450)))), axis([0,730,0.999,1.001]),grid